<%
	If Request.ServerVariables("HTTP_METHOD") = "POST" Then
		Call SaveXML()			
	End if
	
	Call DisplayPreferences()
	
	
	'**************************************************************************************************
	Private Sub DisplayPreferences()
		Dim objDoc
		Dim intCol, intRow, intID
		Dim bLoaded
		Dim sXML
		
		sXML = Request.Cookies("Preferences")
		If Len(Trim(sXML)) > 0 Then
			'Create New DOM Document
			Set objDoc = Server.CreateObject("MSXML2.FreeThreadedDOMDocument")
			objDoc.async = false
			Call objDoc.loadXML(sXML) 	    
			bLoaded = True
		End If
	    	    
		Response.Write "<html><body>"
		Response.Write "<center><h2>Saving preferences with the DOM</h2></center>" 
		Response.Write "<form action='DOMDemo.asp' method='post'>"
		Response.Write "<table border='0'>"
		
		intID = 1
		For intRow = 1 to 10
			Response.Write "<tr>"
			For intCol = 1 to 10
				Response.Write "<td><input type='checkbox' name='Preference' value='" & intID & "'"
				If bLoaded Then
					If Not objDoc.selectSingleNode("//Preference[@ID=" & intID & "]") Is Nothing Then
						Response.Write " CHECKED "
					End If 					
				End If
				Response.Write ">Pref#" & intID & "</td>"
				intID = intID + 1				
			next
			Response.Write "</tr>"
		next
				
		Response.Write "<tr><td colspan='10' align='center'><input type='submit' value='Save Preferences' name='save'><input type='submit' value='Clear Preferences' name='clear'></td></tr>"		
		Response.Write "</table>"
		Response.Write "</form>"
		Response.Write "</body></html>"
		
		Set objDoc = Nothing
	End Sub
	
	'**************************************************************************************************
	Private Sub SaveXML()
	    Dim objDoc, objRootElement  
	    Dim vItem
	    Dim intIndex 
	    	    
	    'Create New DOM Document
	    Set objDoc = Server.CreateObject("MSXML.FreeThreadedDOMDocument")
	    
	    'Create Root Node
	    Set objRootElement = objDoc.createElement("Preferences")	    
	    
	    'Add Root to Document
	    Call objDoc.appendChild(objRootElement)
	    	    
	    'Add Any "What's Going On In" or "news" elements
	    For Each vItem in Request("Preference")
			Call AddChildElement(objRootElement, "Preference", Array("ID", vItem))
	    Next       
		
		If Request("save") <> "" Then
			Response.Cookies("Preferences") = objDoc.xml
		Else
			Response.Cookies("Preferences") = "<Preferences></Preferences>"
		End If
		
		Response.Cookies("Preferences").Path = "/"
		Response.Cookies("Preferences").Expires = Date() + 100		
	    
	    'Cleanup	    
	    Set objRootElement = Nothing
	    Set objDoc = Nothing
	End Sub


	'**************************************************************************************************
	'Purpose: Helper class that adds an element as a child to another element
	Private Function AddChildElement(ByRef CurrentNode, ByVal ElementName, ByRef MyAttributes) 
	    Dim MyElement 
	    Dim i 
	    
	    Set MyElement = CurrentNode.ownerDocument.createElement(ElementName)
	    If UBound(MyAttributes) > LBound(MyAttributes) Then    
	        For i = LBound(MyAttributes) To UBound(MyAttributes) Step 2
	            Call MyElement.setAttribute(MyAttributes(i), MyAttributes(i + 1))
	        Next 
	    End If
	    
	    Set AddChildElement = CurrentNode.appendChild(MyElement)
	End Function
%>